Subject: Re: [PATCH] powerpc: Fix -mcpu= options for SPE-only compiler

From: Segher Boessenkool <[email-masked]>
Date: Sat, 29 Dec 2018 05:40:15 -0600

On Thu, Dec 27, 2018 at 02:32:07AM +0000, Ben Hutchings wrote:
> On Wed, 2018-12-26 at 17:45 -0600, Segher Boessenkool wrote:
> > Hi!
> > 
> > On Wed, Dec 26, 2018 at 02:15:11PM +0000, Ben Hutchings wrote:
> > > GCC for Debian's "powerpcspe" architecture only supports 32-bit
> > > SPE targets, and using -mcpu=powerpc or -mcpu=powerpc64 is a fatal
> > > error.
> > 
> > I don't see where your patch touches -mcpu=powerpc, and I don't see how
> > it would make a difference either?

[ I now see that error fwiw.  Yuck. ]

> Look at the assignments that are conditional on HAS_BIARCH.

Sure, you change how HAS_BIARCH is set.  That has more effects than just
not using -mcpu=powerpc (which is fine, but the message is confusing).

> > > +ifdef CONFIG_PPC64
> > >  ifdef CONFIG_PPC_BOOK3S_64
> > >  ifdef CONFIG_CPU_LITTLE_ENDIAN
> > >  CFLAGS-$(CONFIG_GENERIC_CPU) += -mcpu=power8
> > > @@ -177,6 +178,7 @@ endif
> > >  else
> > >  CFLAGS-$(CONFIG_GENERIC_CPU) += -mcpu=powerpc64
> > >  endif
> > > +endif
> > 
> > How can CONFIG_PPC_BOOK3S_64 be true while CONFIG_PPC64 is fals?  That
> > does not make a lot of sense.
> 
> But there is an "else" part here.

Yeah I see.  It would be better to have fewer nested conditionals here
instead of more...

Segher